Package com.google.protobuf

# Class AbstractMessage.Builder<BuilderType extends AbstractMessage.Builder<BuilderType>>

java.lang.Object
com.google.protobuf.AbstractMessageLite.Builder
com.google.protobuf.AbstractMessage.Builder<BuilderType>

All Implemented Interfaces:
  `Message.Builder`, `MessageLite.Builder`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Cloneable`

Direct Known Subclasses:
  `DynamicMessage.Builder`, `GeneratedMessage.Builder`, `GeneratedMessageV3.Builder`, `MapEntry.Builder`

Enclosing class:
  AbstractMessage

public abstract static class AbstractMessage.Builder<BuilderType extends AbstractMessage.Builder<BuilderType>> extends AbstractMessageLite.Builder implements Message.Builder
A partial implementation of the `Message.Builder` interface which implements as many methods of that interface as possible in terms of other methods.

## Constructor Summary

Constructors
Constructor
Description
`Builder()`

## Method Summary

Modifier and Type
Method
Description
`BuilderType`
`clear()`
Resets all fields to their default values.
`BuilderType`
`clearOneof(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`BuilderType`
`clone()`
Clones the Builder.
`List<String>`
`findInitializationErrors()`
Returns a list of field paths (e.g.
`Message.Builder`
`getFieldBuilder(Descriptors.FieldDescriptor field)`
Get a nested builder instance for the given field.
`String`
`getInitializationErrorString()`
Returns a comma-delimited list of required fields which are not set in this message object.
`Descriptors.FieldDescriptor`
`getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`Message.Builder`
`getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)`
Get a nested builder instance for the given repeated field instance.
`protected UnknownFieldSet.Builder`
`getUnknownFieldSetBuilder()`
`boolean`
`hasOneof(Descriptors.OneofDescriptor oneof)`
TODO(jieluo): Clear it when all subclasses have implemented this method.
`protected BuilderType`
`internalMergeFrom(AbstractMessageLite other)`
`BuilderType`
`mergeFrom(byte[] data)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(byte[] data, int off, int len)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(ByteString data)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
Parse `data` as a message of this type and merge it with the message being built.
`BuilderType`
`mergeFrom(CodedInputStream input)`
Parses a message of this type from the input and merges it with this message.
`BuilderType`
`mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions.
`BuilderType`
`mergeFrom(Message other)`
Merge `other` into the message being built.
`BuilderType`
`mergeFrom(InputStream input)`
Parse a message of this type from `input` and merge it with the message being built.
`BuilderType`
`mergeFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
Parse a message of this type from `input` and merge it with the message being built.
`BuilderType`
`mergeUnknownFields(UnknownFieldSet unknownFields)`
Merge some unknown fields into the `UnknownFieldSet` for this message.
`protected static UninitializedMessageException`
`newUninitializedMessageException(Message message)`
Construct an UninitializedMessageException reporting missing fields in the given message.
`protected void`
`setUnknownFieldSetBuilder(UnknownFieldSet.Builder builder)`
`String`
`toString()`

### Methods inherited from class com.google.protobuf.AbstractMessageLite.Builder

`addAll, addAll, mergeDelimitedFrom, mergeDelimitedFrom, mergeFrom, newUninitializedMessageException`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.Message.Builder

`addRepeatedField, build, buildPartial, clearField, getDescriptorForType, mergeDelimitedFrom, mergeDelimitedFrom, newBuilderForField, setField, setRepeatedField, setUnknownFields`

### Methods inherited from interface com.google.protobuf.MessageLite.Builder

`mergeFrom`

### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

`isInitialized`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`getAllFields, getDefaultInstanceForType, getField, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField`

## Constructor Details

### Builder

public Builder()

## Method Details

### clone

public BuilderType clone()
Description copied from interface: `MessageLite.Builder`
Clones the Builder.

Specified by:
  `clone` in interface `Message.Builder`
Specified by:
  `clone` in interface `MessageLite.Builder`
Specified by:
  `clone` in class `AbstractMessageLite.Builder`
See Also:
  - `Object.clone()`

### hasOneof

public boolean hasOneof(Descriptors.OneofDescriptor oneof)
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `hasOneof` in interface `MessageOrBuilder`

### getOneofFieldDescriptor

public Descriptors.FieldDescriptor getOneofFieldDescriptor(Descriptors.OneofDescriptor oneof)
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `getOneofFieldDescriptor` in interface `MessageOrBuilder`

### clearOneof

public BuilderType clearOneof(Descriptors.OneofDescriptor oneof)
TODO(jieluo): Clear it when all subclasses have implemented this method.

Specified by:
  `clearOneof` in interface `Message.Builder`

### clear

public BuilderType clear()
Description copied from interface: `MessageLite.Builder`
Resets all fields to their default values.

Specified by:
  `clear` in interface `Message.Builder`
Specified by:
  `clear` in interface `MessageLite.Builder`

### findInitializationErrors

public List<String> findInitializationErrors()
Description copied from interface: `MessageOrBuilder`
Returns a list of field paths (e.g. "foo.bar.baz") of required fields which are not set in this message. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

Specified by:
  `findInitializationErrors` in interface `MessageOrBuilder`

### getInitializationErrorString

public String getInitializationErrorString()
Description copied from interface: `MessageOrBuilder`
Returns a comma-delimited list of required fields which are not set in this message object. You should call `MessageLiteOrBuilder.isInitialized()` first to check if there are any missing fields, as that method is likely to be much faster than this one even when the message is fully-initialized.

Specified by:
  `getInitializationErrorString` in interface `MessageOrBuilder`

### internalMergeFrom

protected BuilderType internalMergeFrom(AbstractMessageLite other)

Specified by:
  `internalMergeFrom` in class `AbstractMessageLite.Builder`

### mergeFrom

public BuilderType mergeFrom(Message other)
Description copied from interface: `Message.Builder`
Merge `other` into the message being built. `other` must have the exact same type as `this` (i.e. `getDescriptorForType() == other.getDescriptorForType()`).

Merging occurs as follows. For each field:
* For singular primitive fields, if the field is set in `other`, then `other`'s value overwrites the value in this message.
* For singular message fields, if the field is set in `other`, it is merged into the corresponding sub-message of this message using the same merging rules.
* For repeated fields, the elements in `other` are concatenated with the elements in this message.
* For oneof groups, if the other message has one of the fields set, the group of this message is cleared and replaced by the field of the other message, so that the oneof constraint is preserved.

This is equivalent to the `Message::MergeFrom` method in C++.

Specified by:
  `mergeFrom` in interface `Message.Builder`

### mergeFrom

public BuilderType mergeFrom(CodedInputStream input) throws IOException
Description copied from interface: `MessageLite.Builder`
Parses a message of this type from the input and merges it with this message.

Warning: This does not verify that all required fields are present in the input message. If you call `MessageLite.Builder.build()` without setting all required fields, it will throw an `UninitializedMessageException`, which is a `RuntimeException` and thus might not be caught. There are a few good ways to deal with this:

- Call `MessageLiteOrBuilder.isInitialized()` to verify that all required fields are set before building.
- Use `buildPartial()` to build, which ignores missing required fields.

Note: The caller should call `CodedInputStream.checkLastTagWas(int)` after calling this to verify that the last tag seen was the appropriate end-group tag, or zero for EOF.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeFrom

public BuilderType mergeFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Description copied from interface: `MessageLite.Builder`
Like `MessageLite.Builder.mergeFrom(CodedInputStream)`, but also parses extensions. The extensions that you want to be able to parse must be registered in `extensionRegistry`. Extensions not in the registry will be treated as unknown fields.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Specified by:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### getUnknownFieldSetBuilder

protected UnknownFieldSet.Builder getUnknownFieldSetBuilder()

### setUnknownFieldSetBuilder

protected void setUnknownFieldSetBuilder(UnknownFieldSet.Builder builder)

### mergeUnknownFields

public BuilderType mergeUnknownFields(UnknownFieldSet unknownFields)
Description copied from interface: `Message.Builder`
Merge some unknown fields into the `UnknownFieldSet` for this message.

Specified by:
  `mergeUnknownFields` in interface `Message.Builder`

### getFieldBuilder

public Message.Builder getFieldBuilder(Descriptors.FieldDescriptor field)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given field.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getFieldBuilder` in interface `Message.Builder`

### getRepeatedFieldBuilder

public Message.Builder getRepeatedFieldBuilder(Descriptors.FieldDescriptor field, int index)
Description copied from interface: `Message.Builder`
Get a nested builder instance for the given repeated field instance.

Normally, we hold a reference to the immutable message object for the message type field. Some implementations (the generated message builders) can also hold a reference to the builder object (a nested builder) for the field.

If the field is already backed up by a nested builder, the nested builder is returned. Otherwise, a new field builder is created and returned. The original message field (if one exists) is merged into the field builder, which is then nested into its parent builder.

Specified by:
  `getRepeatedFieldBuilder` in interface `Message.Builder`

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### newUninitializedMessageException

protected static UninitializedMessageException newUninitializedMessageException(Message message)
Construct an UninitializedMessageException reporting missing fields in the given message.

### mergeFrom

public BuilderType mergeFrom(ByteString data) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(byte[] data) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(byte[] data, int off, int len) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(byte[] data, int off, int len, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException
Description copied from interface: `MessageLite.Builder`
Parse `data` as a message of this type and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes in data are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.

### mergeFrom

public BuilderType mergeFrom(InputStream input) throws IOException
Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream)`. Note that this method always reads the entire input (unless it throws an exception). If you want it to stop earlier, you will need to wrap your input in some wrapper stream that limits reading. Or, use `MessageLite.writeDelimitedTo(OutputStream)` to write your message and `MessageLite.Builder.mergeDelimitedFrom(InputStream)` to read it.

Despite usually reading the entire input, this does not close the stream.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `InvalidProtocolBufferException` - the bytes read are not syntactically correct according to the protobuf wire format specification. The data is corrupt, incomplete, or was never a protobuf in the first place.
  `IOException` - an I/O error reading from the stream

### mergeFrom

public BuilderType mergeFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException
Description copied from interface: `MessageLite.Builder`
Parse a message of this type from `input` and merge it with the message being built. This is just a small wrapper around `MessageLite.Builder.mergeFrom(CodedInputStream,ExtensionRegistryLite)`.

Specified by:
  `mergeFrom` in interface `Message.Builder`
Specified by:
  `mergeFrom` in interface `MessageLite.Builder`
Overrides:
  `mergeFrom` in class `AbstractMessageLite.Builder`
Returns:
  this
Throws:
  `IOException`